;Nullsoft Installation Script (NSIS)
;works only for v2.0 Final
;http://www.nullsoft.com/free/nsis/
;http://nsis.sourceforge.net/

SetCompressor lzma

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;Product Info
  !define VER_FILE "1.10"
  !define VER_PRODUCT "DC-Graphic EQ"
  Name "${VER_PRODUCT} ${VER_FILE}"

;--------------------------------
;Configuration

  ;General
  OutFile "DCGaphicEQSetup.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\DSP-worx\${VER_PRODUCT}"
  
  ;Get install folder from registry if available
  InstallDirRegKey HKCU "Software\DSP-worx\${VER_PRODUCT}" ""

;--------------------------------
;Modern UI Configuration

  !define MUI_ABORTWARNING
  !define MUI_UI "${NSISDIR}\Contrib\UIs\modern.exe"
  !define MUI_HEADERBITMAP "${NSISDIR}\Contrib\Graphics\Header\win.bmp"
  !define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\arrow-install.ico"
  !define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\arrow-uninstall.ico"
;  !define MUI_COMPONENTSPAGE_SMALLDESC

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "License.rtf"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY

  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "DC-DCGraphicEQ (binary)" SecCore

  SectionIn 1 RO

  ;Extract out Files
  SetOutPath "$INSTDIR"
  UnRegDll $INSTDIR\DCGraphicEQ.ax
  File "..\Binary\DCGraphicEQ.ax"
  File "..\ReadMe.txt"
  File "..\Binary\register.bat"
  File "..\Binary\unregister.bat"

  ;Register the Filter to DirectShow
  UnRegDll $INSTDIR\DCGraphicEQ.ax
  RegDll $INSTDIR\DCGraphicEQ.ax

  ;Store install folder
  WriteRegStr HKCU "Software\DSP-worx\${VER_PRODUCT}" "" $INSTDIR

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  ; write uninstall strings
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${VER_PRODUCT}" "DisplayName" "${VER_PRODUCT} ${VER_FILE}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${VER_PRODUCT}" "UninstallString" '"$INSTDIR\Uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${VER_PRODUCT}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${VER_PRODUCT}" "NoRepair" 1
    
SectionEnd

;--------------------------------
;Descriptions

  LangString DESC_SecCore ${LANG_ENGLISH} "This installs the binary of the DC-Graphic EQ Filter onto your System."

  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecCore} $(DESC_SecCore)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END
 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  UnRegDll $INSTDIR\DCGraphicEQ.ax
  
  Delete "$INSTDIR\Uninstall.exe"

  RMDir /r "$INSTDIR"
  
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${VER_PRODUCT}"

  DeleteRegKey /ifempty HKCU "Software\DSP-worx"

SectionEnd
