
    (*********************************************************************
     *  DCEQTypes.pas                                                    *
     *                                                                   *
     *  This unit is Part of the DC-Param EQ Filter v1.1                 *
     *                                                                   *
     *  author    : Milenko Mitrovic                                     *
     *  email     : dcoder@dsp-worx.de                                   *
     *  web       : http://dsp-worx.de                                   *
     *  date      : 24-07-2003                                           *
     *                                                                   *
     *  The contents of this file are used with permission, subject to   *
     *  the Mozilla Public License Version 1.1 (the "License"); you may  *
     *  not use this file except in compliance with the License. You may *
     *  obtain a copy of the License at                                  *
     *  http://www.mozilla.org/MPL/MPL-1.1.html                          *
     *                                                                   *
     *  Software distributed under the License is distributed on an      *
     *  "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   *
     *  implied. See the License for the specific language governing     *
     *  rights and limitations under the License.                        *
     *                                                                   *
     *  (C) 2003, 2004 Milenko Mitrovic <dcoder@dsp-worx.de>             *
     *                                                                   *
     *********************************************************************)

unit DCEQTypes;

interface

uses
  DirectShow9;

const
  CLSID_DCEQFilter           : TGUID = '{E4DCD60C-F449-4C78-895B-1FE9F85C7EDD}';
  CLSID_DCEQFilter_PropAbout : TGUID = '{6629A687-111B-4866-AB05-BB76CCE8A619}';
  CLSID_DCEQFilter_PropDSP   : TGUID = '{3AD1BA5F-E7E3-456A-B194-1BBD144F9F4C}';
  IID_IDCEQ                  : TGUID = '{E721999F-CF9A-434B-8281-F5A2C1AD9630}';

  SudPinTypes : array[0..1] of TRegPinTypes =
  (
    (clsMajorType: @MEDIATYPE_AUDIO;clsMinorType: @MEDIASUBTYPE_PCM),
    (clsMajorType: @MEDIATYPE_AUDIO;clsMinorType: @MEDIASUBTYPE_IEEE_FLOAT)
  );

  SudPins : array[0..1] of TRegFilterPins =
  (
    (strName: 'Input'; bRendered: FALSE; bOutput: FALSE; bZero: FALSE; bMany: FALSE; oFilter: nil; strConnectsToPin: 'Output'; nMediaTypes: 2; lpMediaType: @SudPinTypes),
    (strName: 'Output'; bRendered: FALSE; bOutput: TRUE; bZero: FALSE; bMany: FALSE; oFilter: nil; strConnectsToPin: 'Input'; nMediaTypes: 2; lpMediaType: @SudPinTypes)
  );

type
  IDCEQ = interface(IUnknown)
  ['{E721999F-CF9A-434B-8281-F5A2C1AD9630}']
    function getEnabled(out Enabled: LONGBOOL): HRESULT; stdcall;
    function setEnabled(Enabled: LONGBOOL): HRESULT; stdcall;
    function getPreAmp(Channel: integer; out Amp: Single): HRESULT; stdcall;
    function setPreAmp(Channel: integer; Amp: Single): HRESULT; stdcall;
    function getGainDB(Band: integer; Channel: integer; out Value: Single): HRESULT; stdcall;
    function setGainDB(Band: integer; Channel: integer; Value: Single): HRESULT; stdcall;
    function getCPUUsage(out Usage: Double): HRESULT; stdcall;
    function getSpeaker(out Speaker: Cardinal): HRESULT; stdcall;
    function getMinRangeDB(out Range: integer): HRESULT; stdcall;
    function setMinRangeDB(Range: integer): HRESULT; stdcall;
    function getMaxRangeDB(out Range: integer): HRESULT; stdcall;
    function setMaxRangeDB(Range: integer): HRESULT; stdcall;
    function getChannelIndex(out Index: integer): HRESULT; stdcall;
    function setChannelIndex(Index: integer): HRESULT; stdcall;
    function getChannels(out Channels: Integer): HRESULT; stdcall;
    function getPreset(out Preset: PChar): HRESULT; stdcall;
    function setPreset(Preset: PChar): HRESULT; stdcall;
  end;

  TDCEQProfile = record
    PreAmp: array[0..30] of Single;
    Gain: array[0..17, 0..30] of Single;
    MinDB: integer;
    MaxDB: integer;
    Channel: Cardinal;
  end;
  PDCEQProfile = ^TDCEQProfile;

implementation

end.
